//+------------------------------------------------------------------+
//|                                          DimDel_Daily_Candle.mq4 |
//|                        Copyright 2015, MetaQuotes Software Corp. |
//|              http://www.forexfactory.com/showthread.php?t=537112 |
//+------------------------------------------------------------------+
#property copyright "Abhijeet Pandit"
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict

#include <stdlib.mqh>
#include <WinUser32.mqh>
#include <ChartObjects\ChartObjectsTxtControls.mqh>

#define BullColor Lime
#define BearColor Red
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
input bool   UseDefaultPairs = true; // Use the default 28 pairs
string DefaultPairs[] = {"AUDCAD","AUDCHF","AUDJPY","AUDNZD","AUDUSD","CADCHF","CADJPY","CHFJPY","EURAUD","EURCAD","EURCHF","EURGBP","EURJPY","EURNZD","EURUSD","GBPAUD","GBPCAD","GBPCHF","GBPJPY","GBPNZD","GBPUSD","NZDCAD","NZDCHF","NZDJPY","NZDUSD","USDCAD","USDCHF","USDJPY"};
string TradePairs[];
input string OwnPairs = ""; // Comma seperated own pair list
input int   x_axis            =10;
input int   y_axis            =50;
string suffix="";
string prefix="";
input ENUM_TIMEFRAMES TimeFrame  = 1440; //TimeFrame to open chart
extern string usertemplate = "plain_daily";


color BackGrnCol =C'20,20,20';
color LineColor=clrBlack;
color TextColor=clrBlack;

string   _font="Consolas";


int OnInit()
  {
//--- create timer
   EventSetTimer(60);
      
getPrefixSuffix(prefix,suffix);

    if (UseDefaultPairs == true)
      ArrayCopy(TradePairs,DefaultPairs);
    else
      StringSplit(OwnPairs,',',TradePairs);
   
   if (ArraySize(TradePairs) <= 0) {
      Print("No pairs to trade");
      return(INIT_FAILED);
   }     
   
   for(int i=0;i<ArraySize(TradePairs);i++){
   
   SetPanel("BP",0,x_axis-1,y_axis-3,400,451,C'30,30,30',C'61,61,61',1);
   SetPanel("Bar",0,x_axis,y_axis-30,400,27,Maroon,LineColor,1);   
   SetText("Symbol","Symbol        ",x_axis+4,y_axis-25,White,8);
   SetText("Signal","Signal",x_axis+100,y_axis-30,White,8);
   
   Create_Button(IntegerToString(i)+"Pair",TradePairs[i],60 ,14,x_axis+2 ,(i*16)+y_axis,clrDarkGray,LineColor);      
    }
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//--- destroy timer
   EventKillTimer();
      
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
  {
//---
for (int i=0;i<ArraySize(TradePairs);i++) {

      double Opend_1_d     = iOpen(TradePairs[i]+suffix, PERIOD_D1,1);
      double Closed_1_d    = iClose(TradePairs[i]+suffix,PERIOD_D1,1);
      double Highd_1_d     = iHigh(TradePairs[i]+suffix,PERIOD_D1,1);
      double lowD_1_d      = iLow(TradePairs[i]+suffix,PERIOD_D1,1);

      double Opend_2_d     = iOpen(TradePairs[i]+suffix, PERIOD_D1,2);
      double Closed_2_d    = iClose(TradePairs[i]+suffix,PERIOD_D1,2);
      double Highd_2_d     = iHigh(TradePairs[i]+suffix,PERIOD_D1,2);
      double lowD_2_d      = iLow(TradePairs[i]+suffix,PERIOD_D1,2);      
      bool day_1 = 0;
      bool day_2 = 0;
      
      if(Opend_1_d<Closed_1_d)
         {
            day_1 = 0;
         }
      else{
            day_1 = 1;
         }
      if(Opend_2_d<Closed_2_d)
         {
            day_2 = 0;
         }
      else{
            day_2 = 1;
         }            
      
       if(day_1!=day_2)
       {
         if(day_1==0)
         SetObjText("Sig"+IntegerToString(i),CharToStr(233),x_axis+100,(i*16)+y_axis,BullColor,9);
         else if(day_1==1)
         SetObjText("Sig"+IntegerToString(i),CharToStr(234),x_axis+100,(i*16)+y_axis+2,BearColor,9);
         else
         SetObjText("Sig"+IntegerToString(i),CharToStr(54),x_axis+150,(i*16)+y_axis+2,clrWheat,9);                    
       }
       
     }
      
   
         
         
         WindowRedraw();    
  }
//+------------------------------------------------------------------+

#define sectorSize  1936
#define HFILE_ERROR -1
void getPrefixSuffix(string& prefix, string& suffix)
{ 
   int fileHandle = FileOpenHistory("symbols.raw",FILE_BIN|FILE_READ|FILE_SHARE_READ|FILE_WRITE|FILE_SHARE_WRITE);
   if (fileHandle == HFILE_ERROR) {
      Print("Open symbols.raw failed");
      return;
   }

   prefix="";
   suffix="";
   for(int i=0;; i++)
   {
      FileSeek(fileHandle, sectorSize*i, SEEK_SET);
         if (FileIsEnding(fileHandle)) { 
            break; 
         }
string symbolName = FileReadString(fileHandle,12);
      symbolName = StringSubstr(symbolName, 0);
                   
            int pos = StringFind(symbolName,"EURUSD",0);
             if (pos > -1)
             {
                if (pos>0)
                  prefix = StringSubstr(symbolName,0,pos);
                if ((pos+6)<StringLen(symbolName)) {
                  suffix = StringSubstr(symbolName,(pos+6),0);
                  Print("Dashboard detected suffix: "+suffix);
                }
                break;
             }     
   } 

   if (fileHandle>-1)
      FileClose(fileHandle);
}

//+------------------------------------------------------------------+

void SetText(string name,string text,int x,int y,color colour,int fontsize=12)
  {
   if (ObjectFind(0,name)<0)
      ObjectCreate(0,name,OBJ_LABEL,0,0,0);

    ObjectSetInteger(0,name,OBJPROP_XDISTANCE,x);
    ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y);
    ObjectSetInteger(0,name,OBJPROP_COLOR,colour);
    ObjectSetInteger(0,name,OBJPROP_FONTSIZE,fontsize);
    ObjectSetInteger(0,name,OBJPROP_CORNER,CORNER_LEFT_UPPER);
    ObjectSetString(0,name,OBJPROP_TEXT,text);
  }
//+------------------------------------------------------------------+

void SetObjText(string name,string CharToStr,int x,int y,color colour,int fontsize=12)
  {
   if(ObjectFind(0,name)<0)
      ObjectCreate(0,name,OBJ_LABEL,0,0,0);

   ObjectSetInteger(0,name,OBJPROP_FONTSIZE,fontsize);
   ObjectSetInteger(0,name,OBJPROP_COLOR,colour);
   ObjectSetInteger(0,name,OBJPROP_BACK,false);
   ObjectSetInteger(0,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y);
   ObjectSetString(0,name,OBJPROP_TEXT,CharToStr);
   ObjectSetString(0,name,OBJPROP_FONT,"Wingdings");
  }  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void SetPanel(string name,int sub_window,int x,int y,int width,int height,color bg_color,color border_clr,int border_width)
  {
   if(ObjectCreate(0,name,OBJ_RECTANGLE_LABEL,sub_window,0,0))
     {
      ObjectSetInteger(0,name,OBJPROP_XDISTANCE,x);
      ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y);
      ObjectSetInteger(0,name,OBJPROP_XSIZE,width);
      ObjectSetInteger(0,name,OBJPROP_YSIZE,height);
      ObjectSetInteger(0,name,OBJPROP_COLOR,border_clr);
      ObjectSetInteger(0,name,OBJPROP_BORDER_TYPE,BORDER_FLAT);
      ObjectSetInteger(0,name,OBJPROP_WIDTH,border_width);
      ObjectSetInteger(0,name,OBJPROP_CORNER,CORNER_LEFT_UPPER);
      ObjectSetInteger(0,name,OBJPROP_STYLE,STYLE_SOLID);
      ObjectSetInteger(0,name,OBJPROP_BACK,true);
      ObjectSetInteger(0,name,OBJPROP_SELECTABLE,0);
      ObjectSetInteger(0,name,OBJPROP_SELECTED,0);
      ObjectSetInteger(0,name,OBJPROP_HIDDEN,true);
      ObjectSetInteger(0,name,OBJPROP_ZORDER,0);
     }
   ObjectSetInteger(0,name,OBJPROP_BGCOLOR,bg_color);
  }
void ColorPanel(string name,color bg_color,color border_clr)
  {
   ObjectSetInteger(0,name,OBJPROP_COLOR,border_clr);
   ObjectSetInteger(0,name,OBJPROP_BGCOLOR,bg_color);
  }
//+------------------------------------------------------------------+


void Create_Button(string but_name,string label,int xsize,int ysize,int xdist,int ydist,int bcolor,int fcolor)
{
    
   if(ObjectFind(0,but_name)<0)
   {
      if(!ObjectCreate(0,but_name,OBJ_BUTTON,0,0,0))
        {
         Print(__FUNCTION__,
               ": failed to create the button! Error code = ",GetLastError());
         return;
        }
      ObjectSetString(0,but_name,OBJPROP_TEXT,label);
      ObjectSetInteger(0,but_name,OBJPROP_XSIZE,xsize);
      ObjectSetInteger(0,but_name,OBJPROP_YSIZE,ysize);
      ObjectSetInteger(0,but_name,OBJPROP_CORNER,CORNER_LEFT_UPPER);     
      ObjectSetInteger(0,but_name,OBJPROP_XDISTANCE,xdist);      
      ObjectSetInteger(0,but_name,OBJPROP_YDISTANCE,ydist);         
      ObjectSetInteger(0,but_name,OBJPROP_BGCOLOR,bcolor);
      ObjectSetInteger(0,but_name,OBJPROP_COLOR,fcolor);
      ObjectSetInteger(0,but_name,OBJPROP_FONTSIZE,9);
      ObjectSetInteger(0,but_name,OBJPROP_HIDDEN,true);
      //ObjectSetInteger(0,but_name,OBJPROP_BORDER_COLOR,ChartGetInteger(0,CHART_COLOR_FOREGROUND));
      ObjectSetInteger(0,but_name,OBJPROP_BORDER_TYPE,BORDER_RAISED);
      
      ChartRedraw();      
   }

}

void OnChartEvent(const int id,  const long &lparam, const double &dparam,  const string &sparam)
  {
   if(id==CHARTEVENT_OBJECT_CLICK)
  
      {
      
         
      if (StringFind(sparam,"Pair") >= 0) {
         int ind = StringToInteger(sparam);
         ObjectSetInteger(0,sparam,OBJPROP_STATE,0);
         OpenChart(ind);
         return;         
      }   
     }
}

void OpenChart(int ind) {
long nextchart = ChartFirst();
   do {
      string sym = ChartSymbol(nextchart);
      if (StringFind(sym,TradePairs[ind]) >= 0) {
            ChartSetInteger(nextchart,CHART_BRING_TO_TOP,true);
            ChartSetSymbolPeriod(nextchart,TradePairs[ind]+suffix,TimeFrame);
            ChartApplyTemplate(nextchart,usertemplate);
            return;
         }
   } while ((nextchart = ChartNext(nextchart)) != -1);
   long newchartid = ChartOpen(TradePairs[ind]+suffix,TimeFrame);
   ChartApplyTemplate(newchartid,usertemplate);
 }